package no.statnett.ecp.eml;

import no.statnett.ecp.utils.Div;
import no.statnett.ecp.utils.Options;

import java.io.File;
import java.io.IOException;
import java.nio.file.Files;
import java.nio.file.StandardOpenOption;
import java.time.ZoneId;
import java.time.ZonedDateTime;
import java.util.UUID;

public class DummyLogger {
    public static void main(String[] args) throws IOException {
        // Create a file to output a logline that is repeated every QH for a week:

        File f = Options.checkFile("eml-dummy.log", true);


        ZonedDateTime zdt = ZonedDateTime.now(ZoneId.of("UTC")).minusDays(14);

        for (int i = 0; i < 672*2; i++) {
            String logMsg = logMsg(zdt);
            Files.writeString(f.toPath(), logMsg + "\n", StandardOpenOption.APPEND);
            zdt = zdt.plusMinutes(15);
        }

    }


    private static String logMsg(ZonedDateTime zdt) {
        String weekNo = Div.calcWeek(zdt);
        int qh = Div.calcQH(zdt.toInstant().toEpochMilli());

        String dir = "SEND";
        String ack = "Y";
        String delay = "OK";
        int ms = 4951;
        String remote = "50V-KINECT---ATZ";
        String broker = "50V000000000112U";
        String local = "50V-SN-DKBSP-AT2";
        String msgId = UUID.randomUUID().toString();
        int sizeKB = 3;
        String msgType = "NBM-MFRREAM-CIM-PTA47-MTA39";
        String baMsgId = UUID.randomUUID().toString();
        String senderApp = "EML";
        return ECPMsgLogger.makeLogline(zdt, weekNo, qh, dir, ack, delay, ms, remote, broker, local, msgId, sizeKB, msgType, baMsgId, senderApp);
    }
}
